var id = getId();
var Analytics = new Analyt(id);
var version = "0.3.2";

// Wait for device API libraries to load
//
document.addEventListener("deviceready", onDeviceReady, false);

// device APIs are available
//
function onDeviceReady() {
    checkNetworkAccess();
    Analytics = new Analyt(device.uuid);
}

function checkNetworkAccess(){
    if(navigator.connection.type == Connection.NONE) {
        navigator.notification.alert("This app need an internet connection. Please close this app, setup an internet connection and restart the app.", function(){
            if(navigator.app){
                navigator.app.exitApp();
            }else if(navigator.device){
                navigator.device.exitApp();
            }
        }, "Internet connection problem", "Ok")
    }
}

function Analyt(clientId) {
    this.basicArgs = "v=1&tid=UA-49814092-1&cid=" + clientId + "&cd1="+clientId+"&t=";
    
    this.send = function(type, extraArgs) {
        if(document.location.origin.indexOf("localhost") === -1) {
            var postArgs = this.basicArgs + type + extraArgs;
            $.ajax({
              type: "POST",
              url: "https://ssl.google-analytics.com/collect",
              data: postArgs
            });
        }
    };
    
    this.trackAppView = function(view) {
        this.send("appview","&an=kulmap&av=" + version + "&cd=" + view);
    }; 
    
    this.trackEvent = function(cat,action,label) {
        this.send("event","&an=kulmap&av=" + version + "&ec=" + cat + "&ea=" + action + "&el=" + label);
    }; 
}

function getId(){
    if(localStorage["id"] === undefined) {
        localStorage["id"] = makeId();
    }
    return localStorage["id"];
}

function makeId()
{
    var text = "";
    var possible = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";

    for( var i=0; i < 50; i++ )
        text += possible.charAt(Math.floor(Math.random() * possible.length));

    return text;
}