/*
* Adds animation to the floorbuttons.
*/
$(function () {
    "use strict";
    
    var floorSpeed = 300;
    
    function changeClass(element, fromClass, toClass) {
        element.addClass(toClass);
        element.removeClass(fromClass);
    }
    
    $("#floorsInner").css('margin-top', 145 - $(".floorNb:first").height() * $(".floorNbAbove,.floorFirstAbove").length + 'px');
    
    $("#downBtn").on("click.kulo", function () {
        if (!$(".floorNb:last").hasClass("floorNbCurrent") && $(".floorNb:animated").length === 0) {
            $(".floorNbCurrent").each(function () {
                $(this).css('font-weight', 'auto').before().animate({"top": '-=' + 2.5 * $(this).height()}, floorSpeed, function () {
                    changeClass($(this), "floorNbCurrent", "floorFirstAbove");
                });
            });
            $(".floorNbAbove,.floorFirstAbove").each(function () {
                $(this).animate({"top": '-=' + $(this).height()}, floorSpeed, function () {
                    if ($(this).hasClass("floorFirstAbove")) {
                        changeClass($(this), "floorFirstAbove", "floorNbAbove");
                    }
                });
            });
            $(".floorNbBelow").each(function () {
                $(this).animate({"top": '-=' + $(this).height()}, floorSpeed);
            }).promise().done(function () {
                changeClass($(".floorNbBelow:first"), "floorNbBelow", "floorFirstBelow");
            });
            $(".floorFirstBelow").each(function () {
                $(this).animate({"top": '-=' + 2.5 * $(this).height()}, floorSpeed, function () {
                    changeClass($(this), "floorFirstBelow", "floorNbCurrent");
                    var children = $("#floorsInner").children();
                    for(var i = 0; i < children.length; i += 1) {
                        addFloorAnimation(children[i]);
                    }
                });
            });
            map.switchToFloorDown(1);
        }
    });
    
    $("#upBtn").on("click.kulo", function () {
        if (!$(".floorNb:first").hasClass("floorNbCurrent") && $(".floorNb:animated").length === 0) {
            $(".floorNbCurrent").each(function () {
                $(this).css('font-weight', 'auto').before().animate({"top": '+=' + 2.5 * $(this).height()}, floorSpeed, function () {
                    changeClass($(this), "floorNbCurrent", "floorFirstBelow");
                })
            });
            $(".floorNbBelow,.floorFirstBelow").each(function () {
                $(this).animate({"top": '+=' + $(this).height()}, floorSpeed, function () {
                    if ($(this).hasClass("floorFirstBelow")) {
                        changeClass($(this), "floorFirstBelow", "floorNbBelow");
                    }
                });
            });
            $(".floorNbAbove").each(function () {
                $(this).animate({"top": '+=' + $(this).height()}, floorSpeed);
            }).promise().done(function () {
                changeClass($(".floorNbAbove:last"), "floorNbAbove", "floorFirstAbove");
            });
            $(".floorFirstAbove").each(function () {
                $(this).animate({"top": '+=' + 2.5 * $(this).height()}, floorSpeed, function () {
                    changeClass($(this), "floorFirstAbove", "floorNbCurrent");
                    var children = $("#floorsInner").children();
                    for(var i = 0; i < children.length; i += 1) {
                        addFloorAnimation(children[i]);
                    }
                });
            });
            map.switchToFloorUp(1);
        }
    });
});

/*
* Loads the floor buttons with given floor names.
*/
function loadFloors(floorArray, startFloor) {
    var i,
        ground = false,
        first = false,
        floorEl;
    $("#floorsInner").empty();
    for(i = 0; i < floorArray.length; i += 1) {
        if(floorArray[i] === startFloor) {
            ground = true;
            first = true;
            floorEl = "<li class=\"floorNb floorNbCurrent\">" + startFloor + "</li>";
            var children = $('#floorsInner').children();
            if(children.length > 0) {
                children.get(0).classList.add("floorFirstBelow");
                children.get(0).classList.remove("floorNbBelow");
            }
        } else {
            if(ground && first) {
                floorEl = "<li class=\"floorNb floorFirstAbove\">" + floorArray[i] + "</li>";
                first = false;
            } else if(ground) {
                floorEl = "<li class=\"floorNb floorNbAbove\">" + floorArray[i] + "</li>";
            } else {
                floorEl = "<li class=\"floorNb floorNbBelow\">" + floorArray[i] + "</li>";
            }
        }
        $("#floorsInner").prepend(floorEl);
    }
    var children = $("#floorsInner").children();
    for(var i = 0; i < children.length; i += 1) {
        addFloorAnimation(children[i]);
    }
    $("#floorsInner").css('margin-top',(145 - $(".floorNb:first").height() * $(".floorNbAbove,.floorFirstAbove").length) + "px");
}

function addFloorAnimation(el){
    var zeroIdx = findIndex($(el).parent(),$('.floorNbCurrent')[0]);
    var elIdx = $(el).parent().children().index(el);
    var floorSpeed = 300;
    
    function changeClass(element, fromClass, toClass) {
        element.addClass(toClass);
        element.removeClass(fromClass);
    }
    $(el).unbind("click.kulo");
    if(elIdx < zeroIdx) {
        var distance = zeroIdx - elIdx;
        $(el).on("click.kulo", function () {
            if (!$(".floorNb:first").hasClass("floorNbCurrent") && $(".floorNb:animated").length === 0) {
                $(".floorNbCurrent").each(function () {
                    $(this).css('font-weight', 'auto').before().animate({"top": '+=' + (2.5 * $(this).height() + (distance-1) * $(this).height())}, floorSpeed, function () {
                        if(distance === 1) {
                            changeClass($(this), "floorNbCurrent", "floorFirstBelow");
                        } else {
                            changeClass($(this), "floorNbCurrent", "floorNbBelow");
                        }
                        
                    });
                });
                $(".floorNbBelow,.floorFirstBelow").each(function () {
                    $(this).animate({"top": '+=' + distance * $(this).height()}, floorSpeed, function () {
                        if ($(this).hasClass("floorFirstBelow")) {
                            changeClass($(this), "floorFirstBelow", "floorNbBelow");
                        }
                    });
                });
                $(".floorNbAbove,.floorFirstAbove").each(function () {
                    var dist2 = zeroIdx - $(this).parent().children().index(this);
                    var fromClass;
                    if($(this).hasClass('floorNbAbove')) {
                        fromClass = 'floorNbAbove';
                    } else {
                        fromClass = 'floorFirstAbove';
                    }
                    if(distance === dist2) {
                        $(this).animate({"top": '+=' + (2.5 * $(this).height() + (distance-1) * $(this).height())}, floorSpeed).promise().done(function () {
                            changeClass($(this), fromClass, "floorNbCurrent");
                        });
                    } else if (dist2 === distance - 1){
                        $(this).animate({"top": '+=' + (5 * $(this).height() + Math.max(0, (distance-2)) * $(this).height())}, floorSpeed).promise().done(function () {
                            changeClass($(this), fromClass, "floorFirstBelow");
                        });
                    } else if (dist2 === distance + 1){
                        $(this).animate({"top": '+=' + distance * $(this).height()}, floorSpeed).promise().done(function () {
                            changeClass($(this), fromClass, "floorFirstAbove");
                        });
                    } else if (dist2 < distance){
                        $(this).animate({"top": '+=' + (5 * $(this).height() + Math.max(0, (distance-2)) * $(this).height())}, floorSpeed).promise().done(function () {
                            changeClass($(this), fromClass, "floorNbBelow");
                        });
                    } else {
                        $(this).animate({"top": '+=' + distance * $(this).height()}, floorSpeed);
                    }
                }).promise().done(function(){
                    var children = $("#floorsInner").children();
                    for(i = 0; i < children.length; i += 1) {
                        addFloorAnimation(children[i]);
                    }
                });
                map.switchToFloorUp(distance);
            }
        });
    } else if(zeroIdx < elIdx) {
        var distance = elIdx - zeroIdx;
        $(el).on("click.kulo", function () {
            if (!$(".floorNb:last").hasClass("floorNbCurrent") && $(".floorNb:animated").length === 0) {
                $(".floorNbCurrent").each(function () {
                    $(this).css('font-weight', 'auto').before().animate({"top": '-=' + (2.5 * $(this).height() + (distance-1) * $(this).height())}, floorSpeed, function () {
                        if(distance === 1) {
                            changeClass($(this), "floorNbCurrent", "floorFirstAbove");
                        } else {
                            changeClass($(this), "floorNbCurrent", "floorNbAbove");
                        }
                        
                    });
                });
                $(".floorNbAbove,.floorFirstAbove").each(function () {
                    $(this).animate({"top": '-=' + distance * $(this).height()}, floorSpeed, function () {
                        if ($(this).hasClass("floorFirstAbove")) {
                            changeClass($(this), "floorFirstAbove", "floorNbAbove");
                        }
                    });
                });
                $(".floorNbBelow,.floorFirstBelow").each(function () {
                    var dist2 = $(this).parent().children().index(this) - zeroIdx;
                    var fromClass;
                    if($(this).hasClass('floorNbBelow')) {
                        fromClass = 'floorNbBelow';
                    } else {
                        fromClass = 'floorFirstBelow';
                    }
                    if(distance === dist2) {
                        $(this).animate({"top": '-=' + (2.5 * $(this).height() + (distance-1) * $(this).height())}, floorSpeed).promise().done(function () {
                            changeClass($(this), fromClass, "floorNbCurrent");
                        });
                    } else if (dist2 === distance - 1){
                        $(this).animate({"top": '-=' + (5 * $(this).height() + Math.max(0, (distance-2)) * $(this).height())}, floorSpeed).promise().done(function () {
                            changeClass($(this), fromClass, "floorFirstAbove");
                        });
                    } else if (dist2 === distance + 1){
                        $(this).animate({"top": '-=' + distance * $(this).height()}, floorSpeed).promise().done(function () {
                            changeClass($(this), fromClass, "floorFirstBelow");
                        });
                    } else if (dist2 < distance){
                        $(this).animate({"top": '-=' + (5 * $(this).height() + Math.max(0, (distance-2)) * $(this).height())}, floorSpeed).promise().done(function () {
                            changeClass($(this), fromClass, "floorNbAbove");
                        });
                    } else {
                        $(this).animate({"top": '-=' + distance * $(this).height()}, floorSpeed);
                    }
                }).promise().done(function(){
                    var children = $("#floorsInner").children();
                    for(i = 0; i < children.length; i += 1) {
                        addFloorAnimation(children[i]);
                    }
                });
                map.switchToFloorDown(distance);
            }
        });
    }
}

function findIndex(parent,element){
    children = parent.children();
    for(var i = 0; i < children.length;i += 1) {
        if(children[i] === element) {
            return i;
        }
    }
    return -1;
}