$(function () {
    $('#filter-input').on('mouseout',function(){
        if($(this).val() === "") {
            $('#searching').addClass('ui-screen-hidden');
        }
    });
    
    $( "#searching" ).filterable({
        beforefilter: function( event, ui ) {
            $(this).css('visibility','hidden');
            removeSearchInfo();
        },
        filter: function( event, ui ) {
            removeBuildings();
            removeAllButThree();
            $(this).css('visibility','visible');
        }
    });
});

/**
* Adds given building to the search
*/
function addBuildingToSearch(building) {
    "use strict";
    var listItem;
    for(var i = 0;i < building.floorList.length; i++){
        listItem = "<li class=\"ui-screen-hidden floor floor_"+ building.floorList[i] +"\" data-filtertext=\"" + building.tags + " " + building.rooms[building.floorList[i]].join(" ") + "\" data-building='" + building.name + "' data-floor='" + building.floorList[i] + "'><a href=\"#\" onclick=\"clickSearchResult([" + building.lonlat[0] + "," + building.lonlat[1] + "],'" + building.name + "', '" + building.floorList[i] + "')\"><span class='buildingName'>" + building.name + "</span><br/><span class='floorName'>Floor "+ building.floorList[i] +" </span><span class='searchRoom'></span></a></li>";
        $("#searching").append(listItem).listview("refresh");
    }
    listItem = "<li class=\"ui-screen-hidden\" data-building='" + building.name + "' data-filtertext=\"" + building.tags + "\"><a href=\"#\" onclick=\"clickSearchResult([" + building.lonlat[0] + "," + building.lonlat[1] + "],'" + building.name + "')\"><span class='buildingName'>" + building.name + "</span></a></li>";
    $("#searching").append(listItem).listview("refresh");
    $('#searching').trigger('create');
}

function addSearchInfo() {
    "use strict";
    if($('#searchInfo').length === 0) {
        var litem = "<li id='searchInfo' data-filtertext=\"\">More results available. <br/>Please, refine your search for more.</li>";
        $("#searching").append(litem).listview("refresh");
    }
}

function removeSearchInfo() {
    $("#searchInfo").remove();
}

/**
* Handles click on search result with longitude/latitude and name.
*/
function clickSearchResult(lonlat, name, floor) {
    floor = typeof floor !== 'undefined' ? floor : "";
    var floorText = "";
    if(floor !== "") {
        map.visible = "search_"+floor;
        floorText = ", Floor: "+floor;
    }
    Analytics.trackEvent("Search","Searched for "+$('#filter-input').val()+" and clicked on "+name+floorText,"ClickedSearchResult");
    $('#filter-input').val(name).trigger('change');
    $('#searching').addClass('ui-screen-hidden');
    map.goToLocation(lonlat,19);
    map.searchDone(name)
}

$.mobile.filterable.prototype.options.filterCallback = function( index, searchValue ) {
    var searchVals = searchValue.split(" ").clean(" "),
        result = $(this).data('filtertext'),
        i,
        count = 0;
//    if(!$(this).hasClass("floor")) {
//        if($('#searching').html().indexOf(Buildings[$(this).data('building')].name) !== -1){
//            return true;
//        }
//    }
    if(searchVals[searchVals.length-1] === "") {
        searchVals = searchVals.slice(0,searchVals.length-1)
    }
    for(i = 0; i < searchVals.length; i += 1){
        if(result.toLowerCase().indexOf(searchVals[i]) !== -1){
            if($(this).hasClass("floor")){
                var classRooms = hasClassroom(searchVals,Buildings[$(this).data('building')], $(this).data('floor'));
                if(classRooms.length >= 1) {
                    $('.searchRoom',this).html(" - contains "+classRooms.map(function(el) {return "<span class='roomName'>"+el+"</span>"}).join(", ")+"");
                    return false;
                }
            } else {
                count += 1;
            }
        }
    }
    if(count === searchVals.length) {
        return false;
    } else {
        return true;
    }
};

function hasClassroom(searchValues, building, floor) {
    var classrooms = [];
    var roomSearchList = building.rooms[floor];
    var classCount = 0;
    for(var k = 0; k < searchValues.length; k++) {
        var newRoomSearchList = roomSearchList;
        var searchValue = searchValues[k];
        if(building.tags.toLowerCase().split(" ").indexOf(searchValue) === -1 && roomSearchList !== undefined && roomSearchList.join(",").toLowerCase().indexOf(searchValue) !== -1) {
            classCount++;
            newRoomSearchList = [];
            var joinedRooms = roomSearchList.join(",");
            var indices = getIndicesOf(searchValue, joinedRooms, false);
            for(var i = 0; i < indices.length; i++) {
                if(indices[i]-1 === -1 || joinedRooms[indices[i]-1] === "(" || joinedRooms[indices[i]-1] === "|" || joinedRooms[indices[i]-1] === ",") {
                    var reversed = reverse(joinedRooms.slice(0,indices[i]));
                    var sliceStart = 0;
                    if(reversed.indexOf(",") !== -1) {
                        sliceStart = reversed.slice(reversed.indexOf(",")).length;
                    }
                    var tmp = joinedRooms.slice(sliceStart);
                    tmp = tmp.indexOf(",") === -1 ? tmp : tmp.slice(0,tmp.indexOf(","));
                    if(newRoomSearchList.indexOf(tmp) === -1) {
                        newRoomSearchList.push(tmp);
                    }
//                    var sliced = joinedRooms.slice(sliceStart).split("|")[0];
//                    if(sliced.indexOf(",") === -1) {
//                        if(classrooms.indexOf(sliced) === -1) {
//                            classrooms.push(sliced);
//                        }
//                    } else {
//                        if(classrooms.indexOf(sliced.slice(0,sliced.indexOf(","))) === -1) {
//                            classrooms.push(sliced.slice(0,sliced.indexOf(",")));
//                        }
//                    }
                }
            }
//            classrooms.push(building.rooms[floor][building.rooms[floor].indexOf(searchValue)]);
            roomSearchList = newRoomSearchList;
        } else if(roomSearchList.join(",").toLowerCase().indexOf(searchValue) !== -1 || building.tags.toLowerCase().split(" ").indexOf(searchValue) !== -1) {
            roomSearchList = newRoomSearchList;
        } else {
            roomSearchList = [];
        }
    }
    if(classCount >= 1) {
        for(var i = 0; i< roomSearchList.length; i++) {
            classrooms.push(roomSearchList[i].split("|")[0]);
        }
    }
    
    return classrooms;
}

function getIndicesOf(searchStr, str, caseSensitive) {
    var startIndex = 0, searchStrLen = searchStr.length;
    var index, indices = [];
    if (!caseSensitive) {
        str = str.toLowerCase();
        searchStr = searchStr.toLowerCase();
    }
    while ((index = str.indexOf(searchStr, startIndex)) > -1) {
        indices.push(index);
        startIndex = index + searchStrLen;
    }
    return indices;
}

function reverse(s){
    return s.split("").reverse().join("");
}

function removeAllButThree() {
    var list = $('#searching > :not(.ui-screen-hidden)');
    for(var i = 0;i<list.length;i++) {
        if(i > 2 && $(list[i]).attr('id') !== '#searchInfo') {
            $(list[i]).addClass('ui-screen-hidden');
            addSearchInfo();
        }
    }
}

function removeBuildings() {
    var list = $('#searching > :not(.ui-screen-hidden)');
    var buildings = "";
    for(var i = 0;i<list.length;i++) {
        if(!$(list[i]).hasClass('floor')) {
            if(buildings.indexOf($(list[i]).data('building')) !== -1) {
                $(list[i]).addClass('ui-screen-hidden');
            }
        } else {
            buildings += $(list[i]).data('building')+" ";
        }
    }
}